#!/usr/bin/perl
#
# (c) astx (at) aws-it.at, 2019
#
# $Id: calculate_soa_data_from_log_log_plot.pl 1552 2019-01-01 20:02:20Z sta $

use strict;

#---------------------------------------------------------------------------
sub get_soa_data_from_points
#---------------------------------------------------------------------------
{

	# we need 2 points on log log plot and calculate the value of y where x = 1 which is called k
	# delta log y = log y2 - log y1
	# delta log x = log x2 - log x1
	# m = delta logy / delta logx
	my $ref=shift;

	my $x1=shift;
	my $y1=shift;
	my $x2=shift;
	my $y2=shift;

	my $x_from=shift;
	my $x_to=shift;

	#calculate slope
	my $d_logx=log($x2) - log($x1);
	my $d_logy=log($y2) - log($y1);
	my $m=$d_logy / $d_logx;

	# print "slope m = $m\n";

	# calculate intercept on y axis to get constant k
	my $ln_a=log($y2) - $m*log($x2);
	# calculate anti log
	my $k=exp($ln_a);
	# print "log(k):  $ln_a => antilog(k): $k\n";

	# now we have k and m and can calculate y values by iterating x:
	# y = k * x**m
	for my $x ($x_from .. $x_to) {
		my $y=$k * $x ** $m;
		my $oy=sprintf ("%0.2f", $y);
		# print STDERR "$x\t$oy\n";
		$ref->{$x}=$oy;
	}
}

# IXTH80N20L has 3 lines for tc25
my $soa={};
&get_soa_data_from_points($soa, 1, 20, 10, 100, 1, 7);
&get_soa_data_from_points($soa, 7, 77.93, 500, 1, 7, 80);
&get_soa_data_from_points($soa, 80, 6.49, 800, 0.1, 80, 200);

my $x;
my @x;
my @y;
for($x=1; $x < 201; $x++) {
	if (defined $soa->{$x}) {
		# print SDTERR "$x\t$soa->{$x}\n";
		push(@x, $x);
		push(@y, $soa->{$x});
	}
}

print "compose soa_x_25 values @x\n";
print "compose soa_y_25 values @y\n";

# IXTH80N20L has 3 lines for tc75
my $soa={};
&get_soa_data_from_points($soa, 1, 20, 10, 100, 1, 5);
&get_soa_data_from_points($soa, 5, 63, 80, 3.9, 5, 80);
&get_soa_data_from_points($soa, 80, 3.9, 200, 0.74, 80, 200);

my $x;
my @x;
my @y;
for($x=1; $x < 201; $x++) {
	if (defined $soa->{$x}) {
		# print STDERR "$x\t$soa->{$x}\n";
		push(@x, $x);
		push(@y, $soa->{$x});
	}
}

print "compose soa_x_75 values @x\n";
print "compose soa_y_75 values @y\n";
